module CompletenessandTermination where
open import Utils
open import Term
open import Value
open import Normal
open import BigStep
open import Renaming
open import StrongComp

thrm5a$help : forall {Γ}{σ τ}(f f' : Val Γ (σ → τ)){a : Val Γ σ} -> f == f' -> 
 Σ (Val Γ τ) (\v -> (f $ a ⇓ v) ∧  ⌜ f ⌝ʷ $ ⌜ a ⌝ʷ ≡ ⌜ v ⌝ʷ ∧ SCV v) ->
 Σ (Val Γ τ) \v -> (f' $ a ⇓ v) ∧  ⌜ f' ⌝ʷ $ ⌜ a ⌝ʷ ≡ ⌜ v ⌝ʷ ∧ SCV v
thrm5a$help f .f refl⁼ s = s 

mutual
  wkvlem : forall {Γ}{σ}(v : Val Γ σ)(τ : Ty) -> ⌜ v ⌝ʷ [ ↑ τ ] ≡ ⌜ wkv τ v ⌝ʷ
  wkvlem (λv t vs) τ = trans [][]≡ ([]≡ refl (wkelem vs τ)) 
  wkvlem (nev n)   τ = wknlem n τ 
  wkvlem Zv        τ = Z[]≡ 
  wkvlem (Sv v)    τ = trans S[]≡ (S≡ (wkvlem v τ)) 

  wknlem : forall {Γ}{σ}(n : Ne Val Γ σ)(τ : Ty) -> 
           ⌜ n ⌝ʷⁿ [ ↑ τ ] ≡ ⌜ wkn τ n ⌝ʷⁿ
  wknlem (var v)     τ = refl 
  wknlem (app n v)   τ = trans $[]≡ ($≡ (wknlem n τ) (wkvlem v τ)) 
  wknlem (npr n f z) τ = 
    trans pr[]≡ (pr≡ (wknlem n τ) (wkvlem f τ) (wkvlem z τ))

  wkelem : forall {Γ}{Δ}(vs : Env Γ Δ)(τ : Ty) -> 
           ⌜ vs ⌝ˢ ○ ↑ τ ≡ˢ ⌜ wke τ vs ⌝ˢ
  wkelem e        τ = reflˢ 
  wkelem (vs ◂ v) τ = transˢ ○◃≡ˢ (◃≡ (wkelem vs τ) (wkvlem v τ)) 

-- this is too much for the termination checker, before we had N I could write
-- a and b together and it was happy. I wonder if I take the inner recursion out
-- it would go through...
mutual
  lem3a : forall {Γ} σ {v : Val Γ σ} -> 
          SCV v -> Σ (Nf Γ σ) (\m ->  q v ⇓ m × (⌜ v ⌝ʷ  ≡ ⌜ m ⌝))
  lem3a {Γ} N {Zv} sZ = sig Zn (pa qZ refl) 
  lem3a {Γ} N {Sv v} (sS p) = 
    sig (Sn (σ₀ l3av)) (pa (qS (p₀ (σ₁ l3av))) (S≡ (p₁ (σ₁ l3av))))
    where
    l3av = lem3a N {v = v} p
  lem3a {Γ} N {nev n} (sN p) = 
    sig (nen (σ₀ p)) (pa (qn (p₀ (σ₁ p))) (p₁ (σ₁ p)))     
  lem3a {Γ} (σ → τ) {f} sf = 
    sig (λn (σ₀ pv)) 
        (pa (q→ (π₀ (σ₁ sv)) (p₀ (σ₁ pv)))
            (trans η (λ≡ (trans ($≡ (wkvlem f σ) refl) 
            (trans (π₁ (σ₁ sv)) (p₁ (σ₁ pv))))))) 
    where
    a = vZ {Γ} {σ}
    sa = lem3b σ (qv {v = a}) refl
    sv = sf (ε , σ) (nev (var a)) sa
    pv = lem3a τ (π₂ (σ₁ sv))

  lem3b : forall {Γ} σ {n : Ne Val Γ σ}{m : Ne Nf Γ σ} -> 
          qⁿ n ⇓ m -> ⌜ n ⌝ʷⁿ ≡ ⌜ m ⌝ⁿ -> SCV (nev n)
  lem3b {Γ} (σ → τ) {n} {m} p p' = \Δ a sa ->
    let pa = lem3a {Γ ++ Δ} σ sa
        sv = lem3b {Γ ++ Δ}
                   τ
                   (qa (wkqn p Δ) (p₀ (σ₁ pa))) 
                   ($≡ (wk⌜⌝ⁿ {n = n} {n' = m} p' Δ) (p₁ (σ₁ pa))) 
    in  thrm5a$help (nev (wkn++ Δ n)) 
                   (wkv++ Δ (nev n)) 
                   (lemNwk n Δ)
                   (sig (nev (app (wkn++ Δ n) a)) 
                        (tr r$n refl sv)) 
  lem3b {Γ} N {n}{m} p p' = sN (sig m (pa p p'))  

lem3 : forall {Γ}{σ} ->
       ({v : Val Γ σ} -> 
        SCV v -> Σ (Nf Γ σ) (\m ->  q v ⇓ m × (⌜ v ⌝ʷ  ≡ ⌜ m ⌝))) ×
       ({n : Ne Val Γ σ}{m : Ne Nf Γ σ} -> 
          qⁿ n ⇓ m -> ⌜ n ⌝ʷⁿ ≡ ⌜ m ⌝ⁿ -> SCV (nev n))
lem3 {Γ}{σ}= pa (\{v} -> lem3a {Γ} σ {v}) (\{n}{m} -> lem3b {Γ} σ {n}{m})

lem14 : forall {Γ}{σ} -> 
       (f : Val Γ (N → σ → σ)) -> SCV f ->
       (z : Val Γ σ) -> SCV z ->
       (n : Val Γ N) -> SCV n ->
       Σ (Val Γ σ) 
         \v -> pr⇓ n f z v ∧
               pr ⌜ n ⌝ʷ ⌜ f ⌝ʷ ⌜ z ⌝ʷ ≡ ⌜ v ⌝ʷ ∧ 
               SCV v
lem14 f sf z sz Zv sZ = sig z (tr rpZ prZ≡ sz)
lem14 f sf z sz (Sv v) (sS p) = 
 sig (σ₀ fvprfzv) 
     (tr (rpS (π₀ (σ₁ fv)) (π₀ (σ₁ prfzv)) (π₀ (σ₁ fvprfzv))) 
         (trans prS≡ 
                (trans ($≡ (π₁ (σ₁ fv)) (π₁ (σ₁ prfzv)))
                       (π₁ (σ₁ fvprfzv)))) 
         (π₂ (σ₁ fvprfzv)))
  where
  fv = sf ε v p
  prfzv = lem14 f sf z sz v p
  fvprfzv = π₂ (σ₁ fv) ε (σ₀ prfzv) (π₂ (σ₁ prfzv))
lem14 f sf z sz (nev n) (sN p) = 
  sig (nev (npr n f z))
      (tr rpn 
          refl 
          (p₁ lem3 (qpr (p₀ (σ₁ p))
                        (p₀ (σ₁ (p₀ lem3 sf)))
                        (p₀ (σ₁ (p₀ lem3 sz)))) 
                   (pr≡ (p₁ (σ₁ p))
                        (p₁ (σ₁ (p₀ lem3 sf)))
                        (p₁ (σ₁ (p₀ lem3 sz))))))

cor4a : forall {Γ}{σ}(x : Var Γ σ) -> SCV (nev (var x))
cor4a {Γ}{σ} x = lem3b {Γ} σ qv refl

cor4b : forall Γ -> SCE (ide {Γ})
cor4b ε       = tt 
cor4b (Γ , σ) = pa (lem2b (ε , σ) (ide {Γ}) (cor4b Γ)) (cor4a {Γ , σ} {σ} vZ)


mutual
  thrm5a : forall {Γ Δ}{σ}(t : Tm Δ σ)(vs : Env Γ Δ) -> SCE vs ->
          Σ (Val Γ σ) \v -> (t at vs ⇓ v) ∧ (t [ ⌜ vs ⌝ˢ ] ≡ ⌜ v ⌝ʷ) ∧ SCV v
  thrm5a ø (vs ◂ v) (pa se sv) = sig v (tr rø ø≡ sv) 
  thrm5a (λ t) vs se = 
    sig (λv t vs) (tr rλ refl \Δ a sa -> 
      let x = thrm5a t (wke++ Δ vs ◂ a) (pa (lem2b Δ vs se) sa)  
      in  thrm5a$help _ 
                      _ 
                      (lemλwk t vs Δ) 
                      (sig (σ₀ x) (tr (r$λ (π₀ (σ₁ x)))
                                      (trans βσ (π₁ (σ₁ x))) 
                                      (π₂ (σ₁ x)))))
  thrm5a (t $ u) vs se = 
    sig (σ₀ t5tu) 
        (tr (r$ (π₀ (σ₁ t5t)) (π₀ (σ₁ t5u)) (π₀ (σ₁ t5tu))) 
            (trans $[]≡ (trans ($≡ (π₁ (σ₁ t5t)) (π₁ (σ₁ t5u)))
                               (π₁ (σ₁ t5tu))))
            (π₂ (σ₁ t5tu)))
    where
    t5t  = thrm5a t vs se
    t5u  = thrm5a u vs se
    t5tu = π₂ (σ₁ t5t) ε (σ₀ t5u) (π₂ (σ₁ t5u))
  thrm5a (t [ ts ]) vs se = 
    sig (σ₀ t5t) 
        (tr (r[] (π₀ (σ₁ t5ts)) (π₀ (σ₁ t5t))) 
            (trans [][]≡ (trans ([]≡ refl (π₁ (σ₁ t5ts))) (π₁ (σ₁ t5t))))
            (π₂ (σ₁ t5t)))
    where
    t5ts = thrm5b ts vs se
    t5t  = thrm5a t (σ₀ t5ts) (π₂ (σ₁ t5ts)) 
  thrm5a Z vs se = sig Zv (tr rZ Z[]≡ sZ) 
  thrm5a (S n) vs se =
    sig (Sv (σ₀ t5n)) 
        (tr (rS (π₀ (σ₁ t5n))) 
            (trans S[]≡ (S≡ (π₁ (σ₁ t5n))))
            (sS (π₂ (σ₁ t5n))))
    where
    t5n = thrm5a n vs se
  thrm5a (pr n f z) vs se with thrm5a n vs se
  ... | sig (nev n') (tr rn en (sN p)) = 
   sig (nev (npr n' (σ₀ t5f) (σ₀ t5z))) 
       (tr (rp rn (π₀ (σ₁ t5f)) (π₀ (σ₁ t5z)) rpn)
           (trans pr[]≡ (pr≡ en (π₁ (σ₁ t5f)) (π₁ (σ₁ t5z))))
           (p₁ lem3 (qpr (p₀ (σ₁ p))
                         (p₀ (σ₁ (p₀ lem3 (π₂ (σ₁ t5f))))) 
                         (p₀ (σ₁ (p₀ lem3 (π₂ (σ₁ t5z))))))
                    (pr≡ (p₁ (σ₁ p))
                         (p₁ (σ₁ (p₀ lem3 (π₂ (σ₁ t5f)))))
                         (p₁ (σ₁ (p₀ lem3 (π₂ (σ₁ t5z)))))))) 
    where
    t5f = thrm5a f vs se
    t5z = thrm5a z vs se
  ... | sig Zv p = 
    sig (σ₀ t5z)
        (tr (rp (π₀ p) (π₀ (σ₁ t5f)) (π₀ (σ₁ t5z)) rpZ) 
            (trans pr[]≡ 
                   (trans (pr≡ (π₁ p) (π₁ (σ₁ t5f)) (π₁ (σ₁ t5z))) prZ≡)) 
            (π₂ (σ₁ t5z)))  
    where
    t5f = thrm5a f vs se
    t5z = thrm5a z vs se 
  ... | sig (Sv v) (tr rsv esv (sS p)) =
    sig (σ₀ fvprfzv)
         (tr (rp rsv 
                 (π₀ (σ₁ t5f)) 
                 (π₀ (σ₁ t5z))
                 (rpS (π₀ (σ₁ fv)) (π₀ (σ₁ prfzv)) (π₀ (σ₁ fvprfzv)))) 
             (trans pr[]≡  
                   (trans (pr≡ esv (π₁ (σ₁ t5f)) (π₁ (σ₁ t5z)))
                          (trans prS≡ 
                                (trans ($≡ (π₁ (σ₁ fv)) (π₁ (σ₁ prfzv))) 
                                       (π₁ (σ₁ fvprfzv)))))) 
             (π₂ (σ₁ fvprfzv))) 
    where
    t5f = thrm5a f vs se
    t5z = thrm5a z vs se
    fv = π₂ (σ₁ t5f) ε v p
    prfzv = lem14 (σ₀ t5f) (π₂ (σ₁ t5f)) (σ₀ t5z) (π₂ (σ₁ t5z)) v p 
    fvprfzv = π₂ (σ₁ fv) ε (σ₀ prfzv) (π₂ (σ₁ prfzv))

  thrm5b : forall {B Γ Δ}(ts : Tmˢ Γ Δ)(vs : Env B Γ) -> SCE vs ->
           Σ (Env B Δ) 
             \ws -> (ts atˢ vs ⇓ ws) ∧ (ts ○ ⌜ vs ⌝ˢ ≡ˢ ⌜ ws ⌝ˢ) ∧ SCE ws
  thrm5b id vs se = sig vs (tr rid id≡ˢ se)
  thrm5b (ts ◃ t) vs se = 
    sig (σ₀ t5ts ◂ σ₀ t5t)
        (tr (r◃ (π₀ (σ₁ t5ts)) (π₀ (σ₁ t5t)))
            (transˢ ○◃≡ˢ (◃≡ (π₁ (σ₁ t5ts)) (π₁ (σ₁ t5t))))
            (pa (π₂ (σ₁ t5ts)) (π₂ (σ₁ t5t))))
    where
    t5ts = thrm5b ts vs se
    t5t  = thrm5a t vs se 
  thrm5b (↑ σ) (vs ◂ _) (pa se _) = sig vs (tr r↑ ↑◃≡ˢ se)
  thrm5b (ts ○ us) vs se =
    sig (σ₀ t5ts) (tr (r○ (π₀ (σ₁ t5us)) (π₀ (σ₁ t5ts) ) )
                      (transˢ ○○≡ˢ 
                              (transˢ (○≡ reflˢ (π₁ (σ₁ t5us))) 
                                      (π₁ (σ₁ t5ts))))
                      (π₂ (σ₁ t5ts)))
    where
    t5us = thrm5b us vs se
    t5ts = thrm5b ts (σ₀ t5us) (π₂ (σ₁ t5us))

lemid : forall Γ -> id ≡ˢ  ⌜ ide {Γ} ⌝ˢ
lemid ε       = reflˢ 
lemid (Γ , σ) = 
  transˢ ◃id≡ˢ (◃≡ (transˢ (○≡ (lemid Γ) reflˢ) (wkelem (ide {Γ}) σ)) refl) 

prop6 : forall {Γ}{σ}(t : Tm Γ σ) -> Σ (Nf Γ σ) \n -> nf t ⇓ n × (t ≡ ⌜ n ⌝)
prop6 {Γ}{σ} t =
  sig (σ₀ l3at) 
      (pa (nf⇓ (sig (σ₀ t5at) (pa (π₀ (σ₁ t5at)) (p₀ (σ₁ l3at)))))
          (trans id≡ 
                 (trans (trans ([]≡ refl (lemid Γ)) (π₁ (σ₁ t5at)))
                        (p₁ (σ₁ l3at))))) 
  where
  t5at = thrm5a t (ide {Γ}) (cor4b Γ)
  l3at = lem3a {Γ} σ (π₂ (σ₁ t5at))
